// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlShortcutLabel")]
    pub struct ShortcutLabel(Object<ffi::DzlShortcutLabel, ffi::DzlShortcutLabelClass>) @extends gtk::Box, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_shortcut_label_get_type(),
    }
}

impl ShortcutLabel {
    #[doc(alias = "dzl_shortcut_label_new")]
    pub fn new() -> ShortcutLabel {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_shortcut_label_new()).unsafe_cast() }
    }

    #[doc(alias = "dzl_shortcut_label_get_accelerator")]
    #[doc(alias = "get_accelerator")]
    pub fn accelerator(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_full(ffi::dzl_shortcut_label_get_accelerator(
                self.to_glib_none().0,
            ))
        }
    }

    //#[doc(alias = "dzl_shortcut_label_get_chord")]
    //#[doc(alias = "get_chord")]
    //pub fn chord(&self) -> /*Ignored*/Option<ShortcutChord> {
    //    unsafe { TODO: call ffi:dzl_shortcut_label_get_chord() }
    //}

    #[doc(alias = "dzl_shortcut_label_set_accelerator")]
    pub fn set_accelerator(&self, accelerator: &str) {
        unsafe {
            ffi::dzl_shortcut_label_set_accelerator(
                self.to_glib_none().0,
                accelerator.to_glib_none().0,
            );
        }
    }

    //#[doc(alias = "dzl_shortcut_label_set_chord")]
    //pub fn set_chord(&self, chord: /*Ignored*/&ShortcutChord) {
    //    unsafe { TODO: call ffi:dzl_shortcut_label_set_chord() }
    //}

    #[doc(alias = "accelerator")]
    pub fn connect_accelerator_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_accelerator_trampoline<F: Fn(&ShortcutLabel) + 'static>(
            this: *mut ffi::DzlShortcutLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::accelerator\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_accelerator_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "chord")]
    pub fn connect_chord_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_chord_trampoline<F: Fn(&ShortcutLabel) + 'static>(
            this: *mut ffi::DzlShortcutLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::chord\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_chord_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for ShortcutLabel {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for ShortcutLabel {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ShortcutLabel")
    }
}
